@echo off
if exist %~p1adbMenu.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:adbMenu
@title %title% %version% - ADB Menu
color f9
    echo.--------------------------------------------------------------------------------
    echo. [1] Remove Google Factory Reset Protect (FRP)
    echo. [2] Android 5.0+ Remove Exclamation
    echo. [3] Setting China NTP Server
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo.--------------------------------------------------------------------------------
    set selection=
    set /p selection= Please enter the option number: ^>^>
        if "%selection%"=="1" cls && call :removeFRP
        if "%selection%"=="2" cls && call :removeExclamation
        if "%selection%"=="3" cls && call :setNTPServer
        if "%selection%"=="0" cls && exit /b 0
    cls
goto :adbMenu
::
::
:removeFRP
@title %title% %version% - Remove Google Factory Reset Protect (FRP)
    echo. --------------------------------------------------------------------------------
    echo. [*] You must be let device normal boot up, enable USB Debugging and select "Always allow from this comuter".
    echo. [*] If you don't know how to enable USB Debugging, please Google.
    echo. [*] When you remove FRP complete, please restart the device to take effect.
    echo.
    echo. --------------------------------------------------------------------------------
    echo.
    echo. Please press any key to continue, or click the  button in the upper right corner to exit.
    pause > nul

    call "%~dp0enumerateAdbDevices.cmd"

    %adb% shell content insert --uri content://settings/secure --bind name:s:user_setup_complete --bind value:s:1
    if %errorlevel% NEQ 0 (
        color f6
        echo.
        echo. Error: Operation failed!
    ) else (
        color f2
        echo.
        echo. FRP has been removed.
    )

    call "%~dp0killAdbServer.cmd"

    echo.
    echo. Press any key to return.
    pause > nul
exit /b 0
::
::
:removeExclamation
@title %title% %version% - Remove exclamation on the singal icon
    echo. --------------------------------------------------------------------------------
    echo. [*] You must be let device normal boot up, enable USB Debugging and select "Always allow from this comuter".
    echo. [*] If you don't know how to enable USB Debugging, please Google.
    echo. [*] When you remove exclamation complete, turn on airplane mode and then turn it off to take effect.
    echo.
    echo. --------------------------------------------------------------------------------
    echo.
    echo. Please press any key to continue, or click the  button in the upper right corner to exit.
    pause > nul

    call "%~dp0enumerateAdbDevices.cmd"

    REM get SDK version
    for /F "tokens=1" %%X in ('%adb% shell getprop ro.build.version.sdk 2^>^&1') do ( set sdk_version=%%X )

    if %sdk_version% GEQ 25 (
        REM if SDK greater or equal to 25
        %adb% shell "settings put global captive_portal_http_url http://www.qualcomm.cn/generate_204"
        %adb% shell "settings put global captive_portal_https_url https://www.qualcomm.cn/generate_204"
        if !errorlevel! NEQ 0 (
            color f6
            echo.
            echo. Error: Operation failed!
        ) else (
            color f2
            echo.
            echo. Remove exclamation completed!
        )
    ) else (
        %adb% shell "settings put global captive_portal_server g.cn"
        if !errorlevel! NEQ 0 (
            color f6
            echo.
            echo. Error: Operation failed!
        ) else (
            color f2
            echo.
            echo. Remove exclamation completed!
        )
    )

    call "%~dp0killAdbServer.cmd"

    echo.
    echo. Press any key to return.
    pause > nul
exit /b 0
::
::
:setNTPServer
@title %title% %version% - Setting China NTP Server
    echo. --------------------------------------------------------------------------------
    echo. [*] You must be let device normal boot up, enable USB Debugging and select "Always allow from this comuter".
    echo. [*] If you don't know how to enable USB Debugging, please Google.
    echo. [*] When you remove FRP complete, please restart the device to take effect.
    echo.
    echo. --------------------------------------------------------------------------------
    echo.
    echo. Please press any key to continue, or click the  button in the upper right corner to exit.
    pause > nul

    call "%~dp0enumerateAdbDevices.cmd"

    %adb% shell "settings put global ntp_server ntp1.aliyun.com"

    REM get ntp_server
    for /F "tokens=1" %%X in ('%adb% shell "settings get global ntp_server" 2^>^&1') do ( set ntp_server=%%X )

    if %ntp_server% GEQ "ntp1.aliyun.com" (
        color f2
        echo. NTP Server has been set to ntp1.aliyun.com.
    ) else (
        color f6
        echo. Error: NTP Server set failed!
    )

    call "%~dp0killAdbServer.cmd"

    echo.
    echo. Press any key to return.
    pause > nul
exit /b 0
