@echo off
if exist %~p1doFactoryReset.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:doFactoryReset
    if "%device_has_carrier%" EQU "1" (
        echo.
        echo. ------ Erasing Carrier partition ------
        %fastboot% erase carrier
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Note: fastboot erase carrier failed!
            echo. ------------------------------
        )
    )

    echo.
    echo. ------ Erasing Cache partition ------
    %fastboot% erase cache
    if %errorlevel% NEQ 0 (
        color f6
        echo. ------------------------------
        echo. Error: fastboot erase cache failed!
        echo. ------------------------------
    )

    echo.
    echo. ------ Erasing Userdata partition ------
    %fastboot% erase userdata
    if %errorlevel% NEQ 0 (
        color f6
        echo. ------------------------------
        echo. Error: fastboot erase userdata failed!
        echo. ------------------------------
    )

    if "%device_has_ddr%" EQU "1" (
        echo.
        echo. ------ Erasing DDR partition ------
        %fastboot% erase ddr
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Note: fastboot erase ddr failed!
            echo. ------------------------------
        )
    )

    if "%device_has_oldddr%" EQU "1" (
        echo.
        echo. ------ Erasing DDR partition ------
        %fastboot% erase DDR
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Note: fastboot erase DDR failed!
            echo. ------------------------------
        )
    )

    if "%device_has_customize%" EQU "1" (
        echo.
        echo. ------ Erasing Customize partition ------
        %fastboot% erase customize
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Note: fastboot erase customize failed!
            echo. ------------------------------
        )
    )

    if "%device_has_clogo%" EQU "1" (
        echo.
        echo. ------ Erasing Clogo partition ------
        %fastboot% erase clogo
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Note: fastboot erase clogo failed!
            echo. ------------------------------
        )
    )
    REM only MTK devices can erase metadata partition
    if "%device_has_preloader%" EQU "1" (
        echo.
        echo. ------ Erasing Metadata partition ------
        %fastboot% erase metadata
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Note: fastboot erase metadata failed!
            echo. ------------------------------
        )
    )
exit /b 0
