@echo off
if exist %~p1flashRecMenu.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:flashRecMenu
@title %title% %version% - Flash Menu ( Flash Recovery image )
    echo. ================================================================================
    echo.                                          NOTE:
    echo. ================================================================================
    echo. [*] Help you flash Recovery image more easily.
    echo. [*] Note: if recovery image is TWRP, please rename it to "recovery.img" first.
    echo. [*] The computer needs to turn off "Hide extensions of known file types" to see the suffix.
    echo.
    echo. --------------------------------------------------------------------------------
    echo.
    echo. Please press any key to continue, or click the  button in the upper right corner to exit.
    pause > nul
    echo.
    :flashRecOptions
        echo. ================================================================================
        echo.                             Flash Recovery Options
        echo. ================================================================================
        echo. [1] Flash Recovery partition                 [2] Direct boot recovery
        echo.
        echo. [0] ^<^<^< Abandon and return to the Main menu
        echo.
        echo. [*] Direct boot recovery image is useful on devices that do not have real Recovery
        echo. partition (Eg. Motorola Z2 Force).
        echo. --------------------------------------------------------------------------------
        set selection=
        set /p selection= Please enter the option number: ^>^>
            if /i "%selection%"=="1" cls && call :flashRecoveryDirect
            if /i "%selection%"=="2" cls && call :flashRecoveryOnetime
            if /i "%selection%"=="0" cls && exit /b 0
        cls && goto :flashRecOptions

    :flashRecoveryDirect

        call "%~dp0enumerateFbDevices.cmd"

        echo.
        echo. ------ Flashing Recovery image ------
        if exist recovery.img (
            echo.
            echo. ==^> Setting FB mode...
            %fastboot% oem fb_mode_set
            %fastboot% flash recovery recovery.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash recovery failed!
                echo. ------------------------------
            )
            echo.
            echo. ==^> Clean FB mode...
            %fastboot% oem fb_mode_clear
            echo.
            echo. Flash Recovery completed.
            ping 127.0.1 -n 3 >nul 2>nul
            exit /b 0
        ) else (
            color fc
            echo.
            echo. Fatal Error: Recovery image does not exist. this is obviously wrong, please check!
            ping 127.0.1 -n 5 >nul 2>nul
            exit
        )
    exit /b 0

    :flashRecoveryOnetime

        call "%~dp0enumerateFbDevices.cmd"

        echo.
        echo. ------ Direct boot Recovery image ------
        if exist recovery.img (
            %fastboot% boot recovery.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot boot recovery failed!
                echo. ------------------------------
            )
            echo.
            echo. Start Recovery completed.
            ping 127.0.1 -n 3 >nul 2>nul
            exit /b 0
        ) else (
            color fc
            echo.
            echo. Fatal Error: Recovery image does not exist. this is obviously wrong, please check!
            ping 127.0.1 -n 5 >nul 2>nul
            exit
        )

    exit /b 0
exit /b 0
